import Test.QuickCheck

isOdd :: Integer -> Bool
isOdd n = (n `mod` 2 == 1)

odds :: [Integer] -> [Integer]
odds xs  =  [ x | x <- xs, isOdd x ]

oddsRec :: [Integer] -> [Integer]
oddsRec []                  =  []
oddsRec (x:xs) | isOdd x    =  x : oddsRec xs
               | otherwise  =  oddsRec xs
oddsCond :: [Integer] -> [Integer]
oddsCond ws  =
  if null ws then
    []
  else
    let
      x  = head ws
      xs = tail ws
    in
      if isOdd x then
        x : oddsCond xs
      else
        oddsCond xs

prop_odds :: [Integer] -> Bool
prop_odds xs  =  odds xs == oddsRec xs
